#include <ShlObj.h>
#include "SeqIDGenerator.h"
#include "MacFetcher.h"
#include "HddFetcher.h"
#include "md5.h"

#include <windows.h>
#include <Shlobj.h>
#include <sys/stat.h>
#include <intrin.h>
//#include "func.h"


//////////////////////////////////////////////////////////////////////

//#pragma data_seg(".xxx")
unsigned char g_Guid[16] = {0};
volatile LONG g_GuidInitFlag = 0;
//#pragma data_seg()

//#pragma comment(linker, "/section:.xxx,rws")

using namespace std;

namespace QMMacID{

CSeqIDGenerator::CSeqIDGenerator()
{

}

CSeqIDGenerator::~CSeqIDGenerator()
{

}

bool  GetCPUBrand(std::string & strCpuName)
{
	strCpuName.clear();

	CHAR szCPUBrand[49] = {0};	
	const DWORD BRANDID = 0x80000002;

	for (DWORD i = 0; i < 3; ++i)
	{
		DWORD dwOpt = BRANDID + i;
		int cpuinfo[4] = {0};
#if defined(WIN64) || defined(_WIN64)
		__cpuid(cpuinfo,dwOpt);
		memcpy(szCPUBrand + i * 16, &cpuinfo[0], 4);
		memcpy(szCPUBrand + i * 16 + 4, &cpuinfo[1], 4);
		memcpy(szCPUBrand + i * 16 + 8, &cpuinfo[2], 4);
		memcpy(szCPUBrand + i * 16 + 12, &cpuinfo[3], 4);
#else
        DWORD dwEAX, dwEBX, dwECX, dwEDX;

		__asm
		{
			mov eax, dwOpt;
			cpuid;
			mov dwEAX, eax;
			mov dwEBX, ebx;
			mov dwECX, ecx;
			mov dwEDX, edx;
		}  
		memcpy(szCPUBrand + i * 16, &dwEAX, 4);
		memcpy(szCPUBrand + i * 16 + 4, &dwEBX, 4);
		memcpy(szCPUBrand + i * 16 + 8, &dwECX, 4);
		memcpy(szCPUBrand + i * 16 + 12, &dwEDX, 4);

#endif
	}      

	if ( szCPUBrand[0] != 0 )
	{
		strCpuName = szCPUBrand;
	}

	return !strCpuName.empty();
}

HANDLE CSeqIDGenerator::CreateCacheFile(__out HANDLE hFile, __out_ecount_z(dwFileSize)LPSTR tFilePath, __in DWORD dwFileSize, __out DWORD &dwErr)
{
	hFile = INVALID_HANDLE_VALUE;
	string strCacheFilePath;

	dwErr = ERROR_SUCCESS;
	_strnset_s(tFilePath, dwFileSize, '\0', dwFileSize-1);

	char lpAppdataPath[MAX_PATH+1] = {0};
	HRESULT hr = SHGetFolderPathA(NULL, CSIDL_APPDATA | CSIDL_FLAG_CREATE, NULL,  SHGFP_TYPE_CURRENT, lpAppdataPath);
#ifdef UNICODE 
	if (FAILED(hr))
	{
		dwErr = ERROR_PATH_NOT_FOUND;
		goto Cleanup;
	}
#else
	if (FAILED(hr) || S_FALSE == hr)
	{
		dwErr = ERROR_PATH_NOT_FOUND;
		goto Cleanup;
	}
#endif
	strCacheFilePath = lpAppdataPath;
	
	strCacheFilePath = strCacheFilePath + "\\GlobalMgr.db";
	hFile = CreateFileA(strCacheFilePath.c_str(), GENERIC_READ | GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if (INVALID_HANDLE_VALUE != hFile)
	{
		dwErr = ERROR_FILE_EXISTS;
		goto Cleanup;
	}

	if (INVALID_HANDLE_VALUE == hFile && ERROR_FILE_NOT_FOUND  == GetLastError())
	{
		hFile = CreateFileA(strCacheFilePath.c_str(), GENERIC_READ | GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	}

	if (INVALID_HANDLE_VALUE == hFile)
	{
		dwErr = ERROR_CREATE_FAILED;
		goto Cleanup;
	}

Cleanup:

	if (INVALID_HANDLE_VALUE != hFile)
	{
		strncpy_s(tFilePath, dwFileSize, strCacheFilePath.c_str(), dwFileSize-1);
	}
	return hFile;

}

bool CSeqIDGenerator::GetCacheGuid(__in_z LPCSTR tFilePath, 
								   __in_z LPCSTR tstrMacIdMd5, 
								   __in_z LPCSTR tstrPhyDriverMd5, 
								   __in_z LPCSTR tstrCpuidMd5, 
								   __in   bool bMac,
								   __in   bool bHdd,
								   __in   bool bCpu,
								   __out  bool& bNeedCpu,
								   __out_ecount_nz(GUID_LEN)unsigned char pID[GUID_LEN])
{
	bool bRet = false;
	char tFileGuid[FILE_GUID_LEN + 1] = {0};
	char tFileMacIdMd5[FILE_GUID_LEN + 1] = {0};
	char tFilePhyDriverMd5[FILE_GUID_LEN + 1] = {0};
	char tFileCpuidMd5[FILE_GUID_LEN + 1] = {0};

	GetPrivateProfileStringA(SECTION_NAME, KEY_NAME_1, NULL, tFileGuid, FILE_GUID_LEN + 1, tFilePath);
	GetPrivateProfileStringA(SECTION_NAME, KEY_NAME_2, NULL, tFileMacIdMd5, FILE_GUID_LEN + 1, tFilePath);
	GetPrivateProfileStringA(SECTION_NAME, KEY_NAME_3, NULL, tFilePhyDriverMd5, FILE_GUID_LEN + 1, tFilePath);
	GetPrivateProfileStringA(SECTION_NAME, KEY_NAME_4, NULL, tFileCpuidMd5, FILE_GUID_LEN + 1, tFilePath);
	DWORD dwHashWay = GetPrivateProfileIntA(SECTION_NAME, KEY_NAME_5, 0, tFilePath);


	BOOL bMachineAlternate = FALSE;
	if (_stricmp(tFileCpuidMd5, tstrCpuidMd5) != 0)
	{
		bMachineAlternate = TRUE;
	}
	else if ((_stricmp(tFileMacIdMd5, tstrMacIdMd5) != 0)
			&& (_stricmp(tFilePhyDriverMd5, tstrPhyDriverMd5) != 0)
			)
	{
		bMachineAlternate = TRUE;
	}

	if (!bMachineAlternate)
	{
		bRet = true;
	}
	if(FILE_GUID_LEN != strlen(tFileGuid))
	{
		return false;
	}
	if (false != bRet)
	{
		TCHAR temp[3] = {0};

		temp[2] = _T('\0');
		int tempValue = 0;
		for (int i = 0; i<GUID_LEN; i++)
		{
			temp[0] = tFileGuid[2*i];
			temp[1] = tFileGuid[2*i+1];
			_stscanf_s(temp, _T("%x"), &tempValue);
			pID[i] = (unsigned char)tempValue;
		}
	}
	int nNewCounts = 0, nOldCounts = 0;
	int nOldMac = 0, nOldHd = 0, nOldCpu = 0;
	nNewCounts += (false != bCpu)?1:0;
	nNewCounts += (false != bMac)?1:0;
	nNewCounts += (false != bHdd)?1:0;
	nOldCounts += (nOldMac = (strlen(tFileMacIdMd5)>0?1:0));
	nOldCounts += (nOldHd = (strlen(tFilePhyDriverMd5)>0?1:0));
	nOldCounts += (nOldCpu = (strlen(tFileCpuidMd5)>0?1:0));
	if (nNewCounts > nOldCounts)
	{
		bRet = false;
	}
	if (0 == dwHashWay && false != bCpu && (1 != nOldHd || 1 != nOldMac) && 3 != nNewCounts && nNewCounts >= nOldCounts)
	{
		bRet = false;
		bNeedCpu = true;
	}
	return bRet;

}

void CSeqIDGenerator::SetCacheFile(__in HANDLE hFile, 
								   __in_z LPCSTR tFilePath, 
								   __in_z LPCSTR tMacIdMd5, 
								   __in_z LPCSTR tPhyDriverMd5, 
								   __in_z LPCSTR tCpuidMd5, 
								   __in_ecount_nz(dwLen) LPCSTR pID,
								   __in DWORD dwLen)
{
	bool bNeedCloseFile = false;
	if(INVALID_SET_FILE_POINTER != SetFilePointer(hFile, 0, NULL, FILE_BEGIN))
	{
		::SetEndOfFile(hFile);
	}
	DWORD dwHighSize = 0, dwLowSize = 0;
	dwLowSize = GetFileSize(hFile, &dwHighSize);
	if (0 != dwLowSize || 0 != dwHighSize)
	{
		bNeedCloseFile = true;
		hFile = CreateFileA(tFilePath, GENERIC_READ | GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	}
	char *tGuid = new(std::nothrow) char[dwLen*2 + 1];
	if ( tGuid == NULL )
	{
		CloseHandle(hFile);
		return ;
	}
	memset( tGuid , 0 , sizeof(char) * (dwLen*2 + 1) );
	for (size_t i = 0; i< dwLen; i++)
	{
#if _MSC_VER <= 1200  // VC6°汾
		_snprintf(tGuid + 2 * i, 2, "%02x", (unsigned char)pID[i]);
#else
		_snprintf_s(tGuid + 2 * i, 3, 2, "%02x", (unsigned char)pID[i]);
#endif
	}
	tGuid[dwLen*2] = '\0';
	string strFile;
	strFile = strFile + SECTION_NAME_WRITE + NEW_LINE + KEY_NAME_1 + "=" + tGuid + NEW_LINE + KEY_NAME_2 + "=" + tMacIdMd5 + NEW_LINE + KEY_NAME_3 + "=" + tPhyDriverMd5 + NEW_LINE + KEY_NAME_4 + "=" + tCpuidMd5 + NEW_LINE + KEY_NAME_5 + "=1" + NEW_LINE;
	DWORD dwSize = 0;
	WriteFile(hFile, strFile.c_str(), (DWORD)strFile.length()*sizeof(char), &dwSize, NULL);
	if (false != bNeedCloseFile && INVALID_HANDLE_VALUE != hFile)
	{
		CloseHandle(hFile);
	}	
	if (tGuid)
	{
		delete[] tGuid;
		tGuid = NULL ;
	}
}

void GetMd5ArrayAndString(__in std::string& strMd5Seed, __out_ecount_nz(dwArraySize)CHAR tMd5[], __in DWORD dwArraySize, __out_ecount_z(dwStringSize) LPSTR tstrMd5, __in DWORD dwStringSize)
{
	memset(tMd5, 0, dwArraySize);
	memset(tstrMd5, 0, dwStringSize);

	if (2*dwArraySize > dwStringSize)
	{
		return;
	}

	md5_t md5Info;
	md5_init(&md5Info);
	md5_process(&md5Info, strMd5Seed.c_str(), (const unsigned )strMd5Seed.length());
	md5_finish(&md5Info, tMd5);

	unsigned char temp;
	for (size_t i = 0; i < dwArraySize; i++)
	{
		temp = tMd5[i];
#if _MSC_VER <= 1200  // VC6°汾
		_snprintf(tstrMd5 + 2 * i, 2, "%02x", temp);
#else
		_snprintf_s(tstrMd5 + 2 * i, 3, 2, "%02x", temp);
#endif
	}

	tstrMd5[dwStringSize - 1] = _T('\0');
}


bool CSeqIDGenerator::GetSequenceID(unsigned char pID[GUID_LEN])
{
	LONG exchange = 0xff;
	if (InterlockedCompareExchange(&g_GuidInitFlag, exchange, 0) == 0)
	{
		GetSequenceIDImp(g_Guid);
		memcpy(pID, g_Guid, GUID_LEN);
		InterlockedExchange(&g_GuidInitFlag, 1);
	}
	else
	{
		while (g_GuidInitFlag == exchange)
		{
			SwitchToThread();
		}
		memcpy(pID, g_Guid, GUID_LEN);
	}

	return true;
}

bool CSeqIDGenerator::GetSequenceIDImp(unsigned char pID[GUID_LEN])
{
	MACAddress oAddr;
	std::string strSerialNumber;
	std::string strModelNumber;
	std::string strRevisionNumber;
	std::string strCpuId;

	bool bMac = CMacFetcher::GetMAC(oAddr);
	bool bHdd = CHddFetcher::GetPhysicsDriveIdentify(strSerialNumber, strModelNumber, strRevisionNumber);
	bool bCpu = GetCPUBrand(strCpuId);

	char tMacIdMd5[GUID_LEN + 1] = {0};
	char tPhyDriverMd5[GUID_LEN + 1] = {0};
	char tCpuidMd5[GUID_LEN + 1] = {0};

	char tstrMacIdMd5[FILE_GUID_LEN + 1] = {0};
	char tstrPhyDriverMd5[FILE_GUID_LEN + 1] = {0};
	char tstrCpuidMd5[FILE_GUID_LEN + 1] = {0};

	if (bMac)
	{
		GetMd5ArrayAndString(oAddr.ToString(), tMacIdMd5, GUID_LEN, tstrMacIdMd5, FILE_GUID_LEN + 1);
	}
	
	if (bHdd)
	{
		string strHardDriver;
		strHardDriver = strHardDriver + "\0x20" 
			+ strSerialNumber + "\0x20" 
			+ strModelNumber + "\0x20" 
			+ strRevisionNumber;	

		GetMd5ArrayAndString(strHardDriver, tPhyDriverMd5, GUID_LEN, tstrPhyDriverMd5, FILE_GUID_LEN + 1);
	}
	
	if (bCpu)
	{
		GetMd5ArrayAndString(strCpuId, tCpuidMd5, GUID_LEN, tstrCpuidMd5, FILE_GUID_LEN + 1);
	}

	HANDLE hFile = INVALID_HANDLE_VALUE;
	DWORD dwErr = ERROR_SUCCESS;
	char tFilePath[MAX_PATH + 1] = {0};
	bool bRet = false, bGuid = false, bNeedCpu = false;

	hFile = CreateCacheFile(hFile, tFilePath, MAX_PATH + 1, dwErr);
	if (INVALID_HANDLE_VALUE != hFile && ERROR_FILE_EXISTS == dwErr)
	{
		bRet = GetCacheGuid(tFilePath, tstrMacIdMd5, tstrPhyDriverMd5, tstrCpuidMd5, 
			bMac, bHdd, bCpu, bNeedCpu, pID);
	}

	if (bRet)
	{
		if (INVALID_HANDLE_VALUE != hFile)
		{
			CloseHandle(hFile);
		}
		return true;			
	}

	if (bMac)
	{
		std::string strInfo = oAddr.ToString();
		if (bHdd)
		{
			strInfo += "\0x20" 
				+ strSerialNumber + "\0x20" 
				+ strModelNumber + "\0x20" 
				+ strRevisionNumber;		
		}
		if (bNeedCpu)
		{
			strInfo += "\0x20"
				+ strCpuId;
		}

		md5_t md5Info;
		md5_init(&md5Info);
		md5_process(&md5Info, strInfo.c_str(), (const unsigned )strInfo.length());
		md5_finish(&md5Info, pID);
		bGuid = true;
	}
	else if (GetIDFromFile(pID))
	{
		bGuid = true;
	}
	else if (GenerateID(pID))
	{
		SetIDToFile(pID);
		bGuid = true;
	}

	if (false != bGuid && INVALID_HANDLE_VALUE != hFile)
	{
		SetCacheFile(hFile, tFilePath, tstrMacIdMd5, tstrPhyDriverMd5, tstrCpuidMd5, (LPCSTR)pID, GUID_LEN);
	}

	if (INVALID_HANDLE_VALUE != hFile)
	{
		CloseHandle(hFile);
		hFile = INVALID_HANDLE_VALUE;
	}

	return bGuid;
}


bool CSeqIDGenerator::GetSequenceID(unsigned char pID[GUID_LEN], std::string &strMac, std::string &strHdd)
{
	MACAddress oAddr;
	std::string strSerialNumber;
	std::string strModelNumber;
	std::string strRevisionNumber;
	
	strMac.clear();
	strHdd.clear();

	bool bMac = CMacFetcher::GetMAC(oAddr);
	bool bHdd = CHddFetcher::GetPhysicsDriveIdentify(strSerialNumber, strModelNumber, strRevisionNumber);
	if (bMac)
	{
		strMac = oAddr.ToString();
	}
	if (bHdd)
	{
		strHdd = "\0x20" 
			+ strSerialNumber + "\0x20" 
			+ strModelNumber + "\0x20" 
			+ strRevisionNumber;	
	}

	if (bMac)
	{
		std::string strInfo = strMac+strHdd;
		md5_t md5Info;
		md5_init(&md5Info);
		md5_process(&md5Info, strInfo.c_str(), (int)strInfo.length());
		md5_finish(&md5Info, pID);
		return true;
	}
	else if (GetIDFromFile(pID))
	{
		return true;
	}
	else if (GenerateID(pID))
	{
		SetIDToFile(pID);
		return true;
	}

	return false;
}
bool CSeqIDGenerator::GetIDFromFile(unsigned char * pID)
{
	bool bRet = false;
	
#if defined(UNICODE) || defined(_UNICODE)
	std::wstring strComFilePath = GetFilePath(false);
#else
	std::string strComFilePath = GetFilePath(false);
#endif


	HANDLE hf = INVALID_HANDLE_VALUE;
	hf = CreateFile(strComFilePath.c_str(), GENERIC_READ, FILE_SHARE_READ, 0, OPEN_EXISTING, 0, NULL);
	if (hf == INVALID_HANDLE_VALUE)
	{
#if defined(UNICODE) || defined(_UNICODE)
		std::wstring strCurFilePath = GetFilePath(true);
#else
		std::string strCurFilePath = GetFilePath(true);
#endif
		if (!FileExist(strComFilePath) && FileExist(strCurFilePath))
		{
			if (::CopyFile(strCurFilePath.c_str(), strComFilePath.c_str(), FALSE))
			{
				::DeleteFile(strCurFilePath.c_str());
			}
		}
		hf = CreateFile(strCurFilePath.c_str(), GENERIC_READ, FILE_SHARE_READ, 0, OPEN_EXISTING, 0, NULL);
	}

	if (hf != INVALID_HANDLE_VALUE)
	{
		DWORD dwSize = GetFileSize(hf, 0);
		if (16 <= dwSize) 
		{
			DWORD dwRead = 0;
			dwSize = 16;
			if (ReadFile(hf, pID, dwSize, &dwRead, 0) && dwRead == dwSize)
			{
				bRet = true;
			}	
		}
		CloseHandle(hf);
	}

	return bRet;
}

bool CSeqIDGenerator::SetIDToFile(unsigned char * pID)
{
	bool bRet = false;

#if defined(UNICODE) || defined(_UNICODE)
	std::wstring strComFilePath = GetFilePath(false);
#else
	std::string strComFilePath = GetFilePath(false);
#endif

	HANDLE hf = CreateFile(strComFilePath.c_str(), GENERIC_WRITE, FILE_SHARE_READ, 0, CREATE_ALWAYS, 0, NULL);
	if (hf == INVALID_HANDLE_VALUE)
	{
#if defined(UNICODE) || defined(_UNICODE)
		std::wstring strCurFilePath = GetFilePath(true);
#else
		std::string strCurFilePath = GetFilePath(true);
#endif
		hf = CreateFile(strCurFilePath.c_str(), GENERIC_WRITE, FILE_SHARE_READ, 0, CREATE_ALWAYS, 0, NULL);
	}

	if (hf != INVALID_HANDLE_VALUE)
	{
		DWORD dwWrite;
		if (WriteFile(hf, pID, 16, &dwWrite, NULL) 
			&& (16 == dwWrite))
		{
			bRet = true;
		}
		CloseHandle(hf);
	}
	return bRet;
}

bool CSeqIDGenerator::GenerateID(unsigned char * pID)
{
	bool bRet = false;
	HRESULT hr = ::CoInitialize(NULL);
	bool bCoInit = SUCCEEDED(hr);
	
	GUID * pguid = new GUID;
	if ((pguid != NULL) && (S_OK == ::CoCreateGuid(pguid)))
	{
		memcpy(pID, pguid, 16);
		bRet = true;
	}

	delete pguid;
	pguid = NULL ;
	if (bCoInit)
	{
		::CoUninitialize();
	}

	return bRet;	
}

#ifndef CSIDL_COMMON_APPDATA
#define CSIDL_COMMON_APPDATA            0x0023
#endif

#if defined(UNICODE) || defined(_UNICODE)
std::wstring CSeqIDGenerator::GetFilePath(bool bIsCurUser)
#else
std::string CSeqIDGenerator::GetFilePath(bool bIsCurUser)
#endif
{
#if defined(UNICODE) || defined(_UNICODE)
	std::wstring strAppPath;
#else
	std::string strAppPath;
#endif
	//if (strAppPath.empty())
	{
		bool bGetPath = false;
		TCHAR strPath[MAX_PATH] = { 0 };

		if(SHGetSpecialFolderPathW(NULL, strPath, bIsCurUser? CSIDL_APPDATA : CSIDL_COMMON_APPDATA, TRUE))
		{
			strAppPath +=
#if defined(UNICODE) || defined(_UNICODE)
				std::wstring(strPath);
#else
				std::string(strPath);
#endif
			if (bIsCurUser)
			{
				strAppPath += TEXT("\\PHX\\DU");
			}
			else
			{
				strAppPath += TEXT("\\PHX\\DT");
			}

			if (!IsPathExist(strAppPath))
			{
				bGetPath = CreateLocalPath(strAppPath);
			}
			else
			{
				bGetPath = true;
			}
			strAppPath += TEXT("\\Global.db");
		}
	}
	return strAppPath;
}

#if defined(UNICODE) || defined(_UNICODE)
bool CSeqIDGenerator::IsPathExist(const std::wstring& strPathName)
#else
bool CSeqIDGenerator::IsPathExist(const std::string& strPathName)
#endif
{
	bool bRet = false;
	struct _stati64 buf;

#if defined(UNICODE) || defined(_UNICODE)
	std::wstring strFullPath = strPathName;
#else
	std::string strFullPath = strPathName;
#endif

	if(strPathName.empty())
	{
		return false;
	}
	else
	{
		if(strPathName.rfind(_T(":\\")) == strPathName.length() - 2)
		{
		}
		else if(strPathName[strPathName.length() - 1] == L':')
		{
			strFullPath += _T("\\");
		}
		else if(strPathName[strPathName.length() - 1] == L'\\')
		{
			strFullPath.erase(strFullPath.length() - 1);
		}
	}
	
	if(_tstati64(strFullPath.c_str(), &buf) == 0)
	{
		if((buf.st_mode & _S_IFDIR) == _S_IFDIR)
		{
			bRet = true;
		}
		else
		{
			bRet = false;
		}
	}
	else
	{
		bRet = false;
	}
	
	return bRet;
}

#if defined(UNICODE) || defined(_UNICODE)
bool CSeqIDGenerator::CreateLocalPath(const std::wstring& strPathName)
#else
bool CSeqIDGenerator::CreateLocalPath(const std::string& strPathName)
#endif
{
	TCHAR drive[_MAX_DRIVE];
	TCHAR dir[_MAX_DIR];
	TCHAR fname[_MAX_FNAME];
	TCHAR ext[_MAX_EXT];
	
	if(strPathName.empty())
	{
		return false;
	}
	
#if defined(UNICODE) || defined(_UNICODE)
	std::wstring strFullPath = strPathName;
#else
	std::string strFullPath = strPathName;
#endif

	if(strPathName[strPathName.length() - 1] != L'\\')
	{
		strFullPath += 
#if defined(UNICODE) || defined(_UNICODE)
			std::wstring(_T("\\"));
#else
			std::string(_T("\\"));
#endif
	}

#if _MSC_VER <= 1200
	_tsplitpath(strFullPath.c_str(), drive, dir, fname, ext);
#else
	_tsplitpath_s(strFullPath.c_str(), 
		drive, _MAX_DRIVE,
		dir,_MAX_DIR,
		fname, _MAX_FNAME,
		ext, _MAX_EXT);
#endif
#if defined(UNICODE) || defined(_UNICODE)
	std::wstring strDrive = std::wstring(drive) + std::wstring(_T("\\"));
	std::wstring strLeaf = std::wstring(dir);
#else
	std::string strDrive = std::string(drive) + std::string("\\");
	std::string strLeaf = std::string(dir);
#endif	
	if(!IsPathExist(strDrive))
	{
		return false;
	}
	
	if(strLeaf.empty())
	{
		return false;
	}
	else if(strLeaf[0] == L'\\')
	{
		strLeaf.erase(strLeaf.begin());
	}

#if defined(UNICODE) || defined(_UNICODE)
	std::wstring::size_type 
#else
	std::string::size_type 
#endif
		nPos = strLeaf.find_first_of(_T("\\"));

#if defined(UNICODE) || defined(_UNICODE)
	while(nPos != std::wstring::npos)
#else
		while(nPos != std::string::npos)
#endif
	{
#if defined(UNICODE) || defined(_UNICODE)
			std::wstring 
#else
			std::string 
#endif
		 strSubDir = strLeaf.substr(0, nPos);
		strLeaf.erase(0, nPos + 1);
		strDrive += strSubDir + 
#if defined(UNICODE) || defined(_UNICODE)
			std::wstring(_T("\\")); 
#else
			std::string("\\"); 
#endif

		if(!IsPathExist(strDrive))
		{
			if(_tmkdir(strDrive.c_str()))
			{
				return false;
			}
		}
		
		nPos = strLeaf.find_first_of(_T("\\"));
	}
	
	return true;
}

#if defined(UNICODE) || defined(_UNICODE)
bool CSeqIDGenerator::FileExist(const std::wstring& strFileName)
#else
bool CSeqIDGenerator::FileExist(const std::string& strFileName)
#endif
{
	WIN32_FIND_DATA FindFileData;
	HANDLE hFind = FindFirstFile(strFileName.c_str(), &FindFileData);

	bool bRet = false;
	if (hFind == INVALID_HANDLE_VALUE) 
	{
		bRet = false;
	} 
	else 
	{
		bRet = true;
		FindClose(hFind);
	}
	return bRet;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
BOOL GetMachineGUID(std::string& strGUID)
{
	strGUID.clear();

	unsigned char arrGuid[GUID_LEN] = { 0 };
	QMMacID::CSeqIDGenerator oGuid;

	if (oGuid.GetSequenceID(arrGuid))
	{
		std::ostringstream oss;
		for (int i = 0; i < GUID_LEN; ++i)
		{
			oss << std::hex << std::setfill('0') << std::setw(2) << (unsigned short)arrGuid[i];
		}

		strGUID = oss.str();
	}

	return !strGUID.empty();
}

std::string GetMachineGUID(VOID)
{
	std::string strGUID;

	unsigned char arrGuid[GUID_LEN] = { 0 };
	QMMacID::CSeqIDGenerator oGuid;

	if (oGuid.GetSequenceID(arrGuid))
	{
		std::ostringstream oss;
		for (int i = 0; i < GUID_LEN; ++i)
		{
			oss << std::hex << std::setfill('0') << std::setw(2) << (unsigned short)arrGuid[i];
		}

		strGUID = oss.str();
	}

	return strGUID;
}

}