#if !defined(AFX_SEQIDGENERATOR_H__A0A2A8F0_23C1_4B3A_B78F_0BC50564BE5A__INCLUDED_)
#define AFX_SEQIDGENERATOR_H__A0A2A8F0_23C1_4B3A_B78F_0BC50564BE5A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#if _MSC_VER == 1200
#pragma warning( disable : 4251)
#endif


#include <string>
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#ifdef _UNICODE
#define TString std::wstring
#else
#define TString std::string
#endif

#define  MAX_CACHE_SIZE 4*1024

#define SECTION_NAME	"Profile"
#define KEY_NAME_1		"config1"
#define KEY_NAME_2		"config2"
#define KEY_NAME_3		"config3"
#define KEY_NAME_4		"config4"
#define KEY_NAME_5		"config5"
#define NEW_LINE		"\r\n"

#define SECTION_NAME_WRITE "[Profile]"

namespace QMMacID
{
    BOOL GetMachineGUID(std::string& strGUID);
    std::string GetMachineGUID(VOID);

class CSeqIDGenerator  
{
public:
#define GUID_LEN  16
#define FILE_GUID_LEN 2*GUID_LEN
	
	CSeqIDGenerator();
	virtual ~CSeqIDGenerator();
	bool GetSequenceID(unsigned char pID[GUID_LEN]);
	bool GetSequenceID(unsigned char pID[GUID_LEN], std::string &strMac, std::string &strHdd);

protected:
	bool GetIDFromFile(unsigned char * pID);		// ӱļлȡSequenceID
	bool SetIDToFile(unsigned char * pID);			// SequenceID뱾ļ
	bool GenerateID(unsigned char * pID);			// һµSequenceID

#if defined(UNICODE) || defined(_UNICODE)
	static std::wstring GetFilePath(bool bIsCurUser);
	static bool IsPathExist(const std::wstring& strPathName);
	static bool CreateLocalPath(const std::wstring& strPathName);
	static bool FileExist(const std::wstring& strFileName);
#else
	static std::string GetFilePath(bool bIsCurUser);
	static bool IsPathExist(const std::string& strPathName);
	static bool CreateLocalPath(const std::string& strPathName);
	static bool FileExist(const std::string& strFileName);
#endif

private:

	bool GetSequenceIDImp(unsigned char pID[GUID_LEN]);

	HANDLE CreateCacheFile(__out HANDLE hFile, __out_ecount_z(dwFileSize)LPSTR tFilePath, __in DWORD dwFileSize, __out DWORD &dwErr);
	
	bool GetCacheGuid(__in_z LPCSTR tFilePath, 
		__in_z LPCSTR tMacIdMd5, 
		__in_z LPCSTR tPhyDriverMd5, 
		__in_z LPCSTR tCpuidMd5, 
		__in bool bMac,
		__in bool bHdd, 
		__in bool bCpu, 
		__in bool& bNeedCpu, 
		__out_ecount_nz(GUID_LEN)unsigned char pID[GUID_LEN]);

	void SetCacheFile(__in HANDLE hFile, 
		__in_z LPCSTR tFilePath, 
		__in_z LPCSTR tMacIdMd5, 
		__in_z LPCSTR tPhyDriverMd5, 
		__in_z LPCSTR tCpuidMd5, 
		__in_ecount_nz(dwLen) LPCSTR pID, 
		__in DWORD dwLen);
};

}; // namespace QMMacID

#endif // !defined(AFX_SEQIDGENERATOR_H__A0A2A8F0_23C1_4B3A_B78F_0BC50564BE5A__INCLUDED_)
